<template>
  <div v-if="$apollo.loading">
    ...
  </div>
  <div v-else>
    <v-container>
      <v-layout wrap>
        <v-flex sm12 md12 v-for="metric in jumboMockData" :key="metric.label">
          <v-card height="400px">
            <jumbo-text :label="metric.label" :text="metric.text" :series="metric.series"></jumbo-text>
          </v-card>
        </v-flex>
        <v-flex sm12 md12>
          <v-card height="400px">
            <leaflet-map
              :latitude="location.latitude"
              :longitude="location.longitude">
            </leaflet-map>
          </v-card>
        </v-flex>
        <v-flex sm12 md12>
          <v-card height="400px">
            <temperature></temperature>
          </v-card>
        </v-flex>
      </v-layout>
    </v-container>
  </div>
</template>

<script>
import gql from 'graphql-tag'
import jumboText from '../components/jumbo-text.vue'
import leafletMap from '../components/leaflet-map.vue'
import temperature from '../components/temperature.vue'

export default {
  apollo: {
    location: {
      query: gql`query location($id: String!) {
        location(id: $id) {
          id
          label
          latitude
          longitude
          sensors {
            id
            label
          }
        }
      }`,
      update({ location }) {
        this.$store.commit('setPageTitle', location.label)
        return location
      },
      variables() {
        return {
          id: this.$route.params.locationId
        }
      }
    }
  },
  data() {
    return {
      location: {},
      jumboMockData: [
        {
          label: 'Dock',
          text: '75º',
          series: [{
            data: timeSeries(new Date().setHours(0, 0, 0, 0))
          }]
        },
        {
          label: 'Lake (3ft)',
          text: '65º',
          series: [{
            data: timeSeries(new Date().setHours(0, 0, 0, 0))
          }]
        },
        {
          label: 'Humidity',
          text: '40%',
          series: [{
            data: timeSeries(new Date().setHours(0, 0, 0, 0))
          }]
        },
        {
          label: 'Pressure (hPa)',
          text: '996.98',
          series: [{
            data: timeSeries(new Date().setHours(0, 0, 0, 0))
          }]
        }
      ]
    }
  },
  components: {
    jumboText,
    leafletMap,
    temperature
  },
  mounted() {
    this.$store.commit('setPageTitle', '...')
  }
}

function timeSeries(start) {
  return [65, 65, 69, 62, 70, 73, 76, 79, 81, 83, 86, 90, 93, 94, 92, 88, 81, 78, 70, 69, 66, 67, 65, 64].map((value, idx) => {
    // Mix the number up a bit but keep the general trend across sets of series
    const mutatedValue = value - 6 + Math.floor(Math.random() * (10 - 2))
    return [start + (idx * 60 * 60 * 1000), mutatedValue]
  })
}
</script>
